using System;
using Seasar.Framework.Container.Factory;
using Seasar.Framework.Container;

namespace Seasar.Quill
{
    /// <summary>
    /// S2ContainerƘAgׂ̐ÓINXł
    /// </summary>
    /// <remarks>
    /// <see cref="Seasar.Framework.Container.Factory.SingletonS2ContainerFactory"/>
    /// ō쐬ꂽ<see cref="Seasar.Framework.Container.IS2Container"/>܂
    /// </remarks>
    public static class SingletonS2ContainerConnector
    {
        /// <summary>
        /// S2Container̃R|[lgR|[lgw肵Ď擾܂
        /// </summary>
        /// <remarks>
        /// see cref="Seasar.Framework.Container.Factory.SingletonS2ContainerFactory"/>
        /// ō쐬ꂽ<see cref="Seasar.Framework.Container.IS2Container"/>
        /// R|[lg擾܂
        /// </remarks>
        /// <param name="componentName">R|[lg</param>
        /// <returns>R|[lg̃CX^X</returns>
        public static object GetComponent(string componentName)
        {
            // S2Container̃R|[lgR|[lgw肵Ď擾܂
            return GetComponent(componentName, null);
        }

        /// <summary>
        /// S2Container̃R|[lgR|[lgw肵Ď擾܂
        /// </summary>
        /// <remarks>
        /// see cref="Seasar.Framework.Container.Factory.SingletonS2ContainerFactory"/>
        /// ō쐬ꂽ<see cref="Seasar.Framework.Container.IS2Container"/>
        /// R|[lg擾܂
        /// </remarks>
        /// <param name="componentName">R|[lg</param>
        /// <param name="receiptType">󂯑Type</param>
        /// <returns>R|[lg̃CX^X</returns>
        public static object GetComponent(string componentName, Type receiptType)
        {
            if (!SingletonS2ContainerFactory.HasContainer)
            {
                // S2Container쐬ĂȂꍇ͗OX[܂
                throw new QuillApplicationException("EQLL0009");
            }

            // S2Container擾
            IS2Container container = SingletonS2ContainerFactory.Container;

            if (!container.HasComponentDef(componentName))
            {
                // S2ContainerɃR|[lgo^ĂȂꍇ͗OX[
                throw new QuillApplicationException("EQLL0010",
                    new string[] { componentName });
            }

            try
            {
                if (receiptType == null)
                {
                    // S2Container擾R|[lgԂ
                    return container.GetComponent(componentName);
                }
                else
                {
                    // 󂯑̌^w肵S2Container擾R|[lgԂ
                    return container.GetComponent(receiptType, componentName);
                }
            }
            catch (Exception ex)
            {
                // R|[lg̎擾ŗOꍇ͗OX[
                throw new QuillApplicationException("EQLL0011", new string[] { }, ex);
            }
        }
    }
}
