#region Copyright
/*
 * Copyright 2005-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion


using System;
using System.Resources;
using System.Reflection;

namespace Seasar.Quill.Util
{
    /// <summary>
    /// Quillō쐬郁bZ[WNX
    /// </summary>
    public class MessageUtil
    {
        /// <summary>
        /// QuillŎgp郁bZ[Wi[ĂResourceManager
        /// </summary>
        private static readonly ResourceManager MESSAGES_RESOURCE_MANAGER = 
            new ResourceManager("Seasar.Quill.QLLMessages", 
            Assembly.GetExecutingAssembly());

        // object̋̔z
        private static readonly object[] EMPTY_ARRAY = new object[0];

        /// <summary>
        /// bZ[WR[h܂܂ȂbZ[W擾
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        /// <param name="arguments">bZ[Wɖߍޒl̔z</param>
        /// <returns>bZ[WR[h܂܂ȂbZ[W</returns>
        public static string GetSimpleMessage(string messageCode, object[] arguments)
        {
            // bZ[W̃tH[}bgResourceManager擾
            string format = MESSAGES_RESOURCE_MANAGER.GetString(messageCode);

            if (format == null)
            {
                // bZ[WȂꍇ͗OX[
                throw new QuillApplicationException(
                    "EQLL0000", "message not found.");
            }

            if (arguments == null)
            {
                // bZ[Wɖߍޒlnull̏ꍇ͋̔zɕϊ
                arguments = EMPTY_ARRAY;
            }
            
            // tH[}bgɒl𖄂ߍ݃bZ[W쐬
            string message = string.Format(format, arguments);

            // bZ[WԂ
            return message;
        }

        /// <summary>
        /// bZ[WR[h܂ރbZ[W擾
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        /// <param name="arguments">bZ[Wɖߍޒl̔z</param>
        /// <returns>bZ[WR[h܂܂ȂbZ[W</returns>
        public static string GetMessage(string messageCode, object[] arguments)
        {
            // bZ[WR[ht̃bZ[WԂ
            return "[" + messageCode + "]" + GetSimpleMessage(messageCode, arguments);
        }
    }
}
